/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Timers;
using System.Threading;

namespace MassTools.NetworkAwareness.AvailableBW
{
    public class AvailableBW_PTR : MassTool
    {
        public event MassToolDataReadyEventHandler DataReadyEvent;
        // create a timer for frequently test
        System.Timers.Timer sendingTimer = null;
        string dst_addr;
        PTRServer mServer;

        public AvailableBW_PTR()
        {
            sendingTimer = new System.Timers.Timer(5000);
            sendingTimer.Elapsed += new ElapsedEventHandler(sendingTimer_Elapsed);
        }

        public override bool Start()
        {
            sendingTimer.Start();
            return true;
        }

        public override bool Stop()
        {
            sendingTimer.Stop();
            return true;
        }

        public void AddSubscriber(MassToolDataReadyEventHandler handler)
        {
            DataReadyEvent += handler;
        }

        public void SetPacketSize(Int32 n)
        {
        }

        public void SetPacketNum(Int32 n)
        {
        }

        public void SetInterval(Int32 millisecond)
        {
            sendingTimer.Interval = millisecond;
        }

        public void SetRemoteAddr(string strAddr)
        {
            dst_addr = strAddr;
        }

        public void client_ABWReadyEvent(object sender, PTREventArgs e)
        {
            DataReadyEvent(this, new MassTools.MassToolEventArgs(e.m_PTR_bw));
        }

        private void sendingTimer_Elapsed(object sender, ElapsedEventArgs e)
        {
            PTRClient client = new PTRClient();
            client.ABWReadyEvent += new PTRClient.ABWReadyEventHandler(client_ABWReadyEvent);
            client.SetRemoteAddr(dst_addr);
            client.Start();
        }

        public void StartServer()
        {
            // start the server side as each node is both server and client
            Thread serverThread = new Thread(new ThreadStart(serverfun));
            serverThread.Start();
        }

        private void serverfun()
        {
            mServer = new PTRServer();
            mServer.Start();
        }

        public void StopServer()
        {
            mServer.Stop();
        }
    }
}
