/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.Text;

namespace MassTools.NetworkAwareness.AvailableBW
{
    class Common
    {
        public const int BUF_SIZE = 4096;
        public const int MAXIPSTRLEN = 16;
        public const int START_PORT = 10 * 1024;
        public const int END_PORT = 0xFFFF;
        public const int ProbeNum = 60;
        public const int PacketSize = 500;
        public const int MaxProbeNum = 256;

        //the maximum calm period of a probing client
        public const int CLIENTTIMEOUT = 30;

        //used by sanity_check
        public const double BinWidth = 0.000025;

        //used by binary_probing & probing
        public const int SmallDelay = 50;
        public const int BigDelay = 500;
        public const int DelayStep = 100;
        public const int MaxPhaseNum = 1024;
        public const double TurningGapAdjustment = 0.0001;
        public const int TurningIndexAdjustment = 2;

        //max number of repeast for each probing gap value
        public const int MaxRepeat = 20;

        public const int PhaseSleep = 0;

        public struct pkt_rcd_t
        {
            public Int64 tick;
            public UInt32 seq;

            public byte[] ToByteArray()
            {
                byte[] bat, bas;
                bat = BitConverter.GetBytes(tick);
                bas = BitConverter.GetBytes(seq);

                byte[] res = new byte[bat.Length + bas.Length];
                int idx = 0;
                
                bat.CopyTo(res, idx);
                idx += bat.Length;

                bas.CopyTo(res, idx);
                idx += bas.Length;

                return res;
            }

            public void FromByteArray(byte[] dt)
            {
                int idx = 0;

                int TICKLEN = sizeof(Int64);
                int SEQLEN = sizeof(UInt32);

                byte[] bat = new byte[TICKLEN];
                Array.Copy(dt, idx, bat, 0, TICKLEN);
                idx += TICKLEN;
                tick = BitConverter.ToInt64(bat, 0);

                byte[] bas = new byte[SEQLEN];
                Array.Copy(dt, idx, bas, 0, SEQLEN);
                idx += SEQLEN;
                seq = BitConverter.ToUInt32(bas, 0);
            }

            public static int Size()
            {
                return sizeof(Int64) + sizeof(UInt32);
            }
        };
    }
}
