/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;

namespace Masslets.ImageProcess
{
    interface DataInput
    {
        MassletDataReadyEventHandler GetSubscriber();
    }

    public class ImageSender : Masslet, DataInput
    {
        Socket m_localSocket;
        EndPoint[] m_remoteEndPoints;

        // delegate instanc for data receiving
        public MassletDataReadyEventHandler DataRequestHandler;


        public ImageSender()
        {
            m_localSocket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
        }

        MassletDataReadyEventHandler DataInput.GetSubscriber()
        {
            if (DataRequestHandler == null)
                DataRequestHandler = new MassletDataReadyEventHandler(DataReceiveCallBack);
            return DataRequestHandler;
        }

        public void DataReceiveCallBack(object sender, MassletEventArgs e)
        {
            foreach (EndPoint ep in m_remoteEndPoints)
            {
                m_localSocket.SendTo(e.mData, ep);
            }
        }

        public override bool Start()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public override bool Stop()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void SetDestinations(EndPoint[] remotes)
        {
            m_remoteEndPoints = remotes;
        }

    }
}
