/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace Masslets.ImageProcess
{
    // for message exchange, structure is more efficient than serializable class
    public struct IMAGEMSG
    {
        public int width;
        public int height;
        public int pdata;
        public int length;

        public IMAGEMSG(int w, int h, int p, int l)
        {
            width = w;
            height = h;
            pdata = p;
            length = l;
        }

        public IMAGEMSG(int w, int h, IntPtr p, int l)
        {
            width = w;
            height = h;
            pdata = (int)p;
            length = l;
        }
    }

    [Serializable]
    public class UDPMSG
    {
        IPAddress addr;
        byte[] data;
        public UDPMSG(IPAddress ip, byte[] dt)
        {
            addr = ip;
            data = dt;
        }
        public byte[] mData
        {
            get
            {
                return data;
            }
            set
            {
                data = value;
            }
        }

        public IPAddress mIPAddr
        {
            get
            {
                return addr;
            }
            set
            {
                addr = value;
            }
        }

        public byte[] Serialize()
        {
            MemoryStream ms = new MemoryStream();
            BinaryFormatter bFormatter = new BinaryFormatter();
            bFormatter.Serialize(ms, this);
            return ms.ToArray();
        }
        public static UDPMSG DeSerialize(byte[] dt)
        {
            MemoryStream ms = new MemoryStream(dt);
            BinaryFormatter bFormatter = new BinaryFormatter();
            UDPMSG retVal = (UDPMSG)bFormatter.Deserialize(ms);
            return retVal;
        }
    }
}
